#pragma once
#include "memory/Paging.h"
#include "utils/Result.h"

struct AddressSpace
{
    static Result<AddressSpace> create();

    void destroy();

    void clear();

    AddressSpace clone();

    PageTable* get_pml4()
    {
        return m_pml4;
    }

  private:
    PageTable* m_pml4;
};