#ifndef _LUNA_DIRENT_H
#define _LUNA_DIRENT_H

#include <luna/os-limits.h>
#include <sys/types.h>

struct luna_dirent
{
    ino_t inode;
    char name[NAME_MAX];
    size_t total;
    off_t offset;
};

#ifdef __cplusplus
extern "C"
{
#endif

    /* Retrieve directory entries from the kernel. This is the raw interface, use readdir() instead. */
    ssize_t getdents(int fd, struct luna_dirent* buf, size_t count);

#ifdef __cplusplus
}
#endif

#endif